<?php
session_start();

//بررسی لاگین بودن کاربر و دریافت اطلاعات کاربر از دیتابیس
if(isset($_SESSION['backendbaz_user_id']) || isset($_COOKIE['backendbaz_user_id'])){
    //اگر کاربر از قبل وارد سایت شده باشد، به صفحه پروفایل هدایت شود
    header('location: profile.php');
}


$error = '';

if(isset($_SESSION['token']) && isset($_POST['token']) && $_SESSION['token'] == $_POST['token']){
    if(isset($_POST['login'])) {
        $userlogin = trim($_POST['userlogin']);//نام کاربری یا ایمیل
        $password = trim($_POST['password']);

        $remember = (isset($_POST['remember']))?1:0;

        include "db.php";

        //جلوگیری از حملات XSS
        $userlogin = htmlspecialchars($userlogin);

        $check_userlogin = mysqli_query($conn, "SELECT * FROM users WHERE username = '$userlogin' OR email = '$userlogin' ");
        if(mysqli_num_rows($check_userlogin) == 0) {
            $error = 'نام کاربری یا ایمیل اشتباه است.';
        } else {
            $user_info = mysqli_fetch_array($check_userlogin);
            if(md5(md5($password)) == $user_info['password']) {
                //اطلاعات کاربر صحیح است. ساخت کوکی و ریدایرکت به صفحه پروفایل کاربر

                $_SESSION['backendbaz_user_id'] = $user_info['id'];
                if($remember) {
                    setcookie('backendbaz_user_id', $user_info['id'], time()+(30*24*60*60), '/');
                }

                header('location: profile.php');

            } else {
                $error = 'کلمه عبور وارد شده اشتباه است.';
            }
        }
    }
}
//جلوگیری از ثبت نام ربات ها با استفاده از توکن و سشن ها
//برای ساخت یک توکن یونیک، از آی پی کاربر و زمان کنونی استفاده می کنیم
$ip = $_SERVER['REMOTE_ADDR'];
$now = time();
$token = md5($ip.$now);
$_SESSION['token'] = $token;

?>


<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>ورود</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <style>
    body {
        direction: rtl;
        text-align: right;
    }
    </style>
</head>
<body>
    
    <div class="container">
        <div class="d-flex justify-content-center">
            <div class="card w-50 p-4 mt-4">
                <?php
                if(isset($_GET['registered'])) {
                    echo 'ثبت نام شما با موفقیت انجام شد. اکنون می توانید وارد سایت شوید.';
                } elseif(isset($_GET['reset'])) {
                    echo 'پسورد شما با موفقیت تغییر کرد. اکنون می توانید وارد سایت شوید.';
                }
                if($error != ''){
                    echo $error;
                }
                ?>

                <form action="login.php" method="post">
                    <input type="text" name="userlogin" id="userlogin" class="form-control" placeholder="نام کاربری یاایمیل" value="<?= $userlogin??'' ?>">
                    <input type="password" name="password" id="password" class="form-control" placeholder="کلمه عبور" value="<?= $password??'' ?>">

                    <input type="checkbox" name="remember" id="remember" value="1" <?= ((isset($remember)) && $remember == 1)?'checked':'' ?>> مرا به خاطر بسپار<br>

                    <input type="submit" value="ورود" class="btn btn-success" name="login">
                    <input type="hidden" name="token" value="<?= $token ?>"><br>
                    <a href="forget-pass.php">فراموشی کلمه عبور</a>
                </form>
            </div>
        </div>
    </div>

    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>

</body>
</html>