<?php
session_start();
//بررسی لاگین بودن کاربر و دریافت اطلاعات کاربر از دیتابیس
if(isset($_SESSION['backendbaz_user_id']) || isset($_COOKIE['backendbaz_user_id'])){
    //اگر کاربر از قبل وارد سایت شده باشد، به صفحه پروفایل هدایت شود
    header('location: profile.php');
}


$error = [];

function check_username($username, $error) {
    if($username == '') {
        $error[] = 'نام کاربری نباید خالی باشد.';
    }
    if(strlen($username) < 4) {
        $error[] = 'نام کاربری نمی تواند کمتر از 4 حرف باشد';
    }

    if(strlen($username) > 14) {
        $error[] = 'نام کاربری باید کمتر از 14 کاراکتر باشد.';
    }

    if(strpos($username, ' ') !== false) {
        $error[] = 'نام کاربری نمی تواند شامل کاراکتر فاصله خالی باشد.';
    }

    if(strpos($username, '@') !== false) {
        $error[] = 'نام کاربری نمی تواند شامل @ باشد';
    }

    return $error;
}

function is_password_strong($password)
{
    if(strlen($password) < 6) return false;
    $loweralpha = 'abcdefghijklmnopqrstuvwxyz';
    $upperalpha = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $numbers = '0123456789';
    $specialchars = '!@#$%^&*()_+-=~';

    //بررسی وجود حداقل یک حرف کوچک در پسورد
    $lower_flag = false;
    foreach(str_split($loweralpha) as $l) {
        if(strpos($password, $l) !== false) {
            $lower_flag = true;
            break;
        }
    }
    if($lower_flag == false) return false; 

    //بررسی وجود حداقل یک حرف بزرگ در پسورد
    $upper_flag = false;
    foreach(str_split($upperalpha) as $l) {
        if(strpos($password, $l) !== false) {
            $upper_flag = true;
            break;
        }
    }
    if($upper_flag == false) return false; 

    //بررسی وجود حداقل یک عدد در پسورد
    $number_flag = false;
    foreach(str_split($numbers) as $l) {
        if(strpos($password, $l) !== false) {
            $number_flag = true;
            break;
        }
    }
    if($number_flag == false) return false; 

    //بررسی وجود حداقل یک کاراکتر خاص در پسورد
    $char_flag = false;
    foreach(str_split($specialchars) as $l) {
        if(strpos($password, $l) !== false) {
            $char_flag = true;
            break;
        }
    }
    if($char_flag == false) return false; 

    //در غیر اینصورت
    return true;

}


if(isset($_SESSION['token']) && isset($_POST['token']) && ($_POST['token'] == $_SESSION['token'])) {

    if(isset($_POST['register'])) {
        $username = trim($_POST['username']);
        $email = trim($_POST['email']);
        $password = trim($_POST['password']);
        $re_password = trim($_POST['re_password']);

        //اعتبار سنجی نام کاربری
        $error = check_username($username, $error);

        //اعتبار سنجی ایمیل
        if(!filter_var($email, FILTER_VALIDATE_EMAIL)) {
            $error[] = 'ایمیل وارد شده معتبر نیست.';
        }

        //سنجش قدرت پسورد
        //پسورد باید حداقل 6 حرف و شامل حرف کوچک، حرف بزرگ، عدد و یک کاراکتر خاص باشد
        if(!is_password_strong($password)) {
            $error[] = 'پسورد باید حداقل 6 حرف و شامل حرف کوچک، حرف بزرگ، عدد و یک کاراکتر خاص باشد ';
        }

        if($password != $re_password) {
            $error[] = 'پسورد با تکرار آن برابر نیست.';
        }

        if(empty($error)) {
            //خطایی وجود ندارد در نتیجه کاربر را در دیتابیس وارد می کنیم
            include "db.php";

            $username = htmlspecialchars($username);
            $email = htmlspecialchars($email);
        


            //بررسی تکراری نبودن نام کاربری و ایمیل
            $check = mysqli_query($conn, "SELECT * FROM users WHERE username='$username'");
            if(mysqli_num_rows($check) > 0) {
                $error[] = 'نام کاربری تکراری است!';
            }

            $check = mysqli_query($conn, "SELECT * FROM users WHERE email='$email'");
            if(mysqli_num_rows($check) > 0) {
                $error[] = 'ایمیل تکراری است!';
            }

            if(empty($error)) {
                $password = md5(md5($password));
                $sql = "INSERT INTO users (username, email, password) VALUES ('$username', '$email', '$password')";
                $new_user = mysqli_query($conn, $sql);
        
                if($new_user) {
                    //ریدایرکت به صفحه لاگین
                    header('location: login.php?registered=true');
                }
            }
        }

    }
}

$ip = $_SERVER['REMOTE_ADDR'];
$now = time();
$token = md5($ip.$now);
$_SESSION['token'] = $token;

?>
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>ثبت نام</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
    <style>
    body {
        direction: rtl;
        text-align: right;
    }
    </style>
</head>
<body>
    
    <div class="container">
        <div class="d-flex justify-content-center">
            <div class="card mt-4 p-4 w-50">
                <?php
                    if(!empty($error)) {
                        foreach($error as $err) {
                            echo '<li>'.$err.'</li>';
                        }
                    }
                ?>

                <form action="" method="post">
                    <input type="text" name="username" id="username" class="form-control" placeholder="نام کاربری" value="<?= $username??'' ?>">
                    <input type="email" name="email" id="email" class="form-control" placeholder="ایمیل" value="<?= $email??'' ?>">
                    <input type="password" name="password" id="password" class="form-control" placeholder="کلمه عبور" value="<?= $password??'' ?>">
                    <input type="password" name="re_password" id="re_password" class="form-control" placeholder="تکرار کلمه عبور" value="<?= $re_password??'' ?>">

                    <input type="submit" value="ثبت نام" name="register" class="btn btn-success">
                    <input type="hidden" name="token" value="<?= $token ?>">
                </form>
            </div>
        </div>
    </div>
    
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>
</body>
</html>